﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using Infragistics.Documents.Excel;

namespace UltraGridExcelExportWithStatusBar
{
    public partial class Form1 : Form
    {
        private const int maxRows = 10;
        private BackgroundWorker backgroundWorker1;

        public Form1()
        {
            InitializeComponent();

            this.backgroundWorker1 = new System.ComponentModel.BackgroundWorker();
            backgroundWorker1.DoWork += new DoWorkEventHandler(backgroundWorker1_DoWork);
            backgroundWorker1.RunWorkerCompleted += new RunWorkerCompletedEventHandler(backgroundWorker1_RunWorkerCompleted);

            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            dt.Columns.Add("ID", typeof(int));
            dt.Columns.Add("A");
            dt.Columns.Add("B");
            dt.Columns.Add("C");

            DataTable dt2 = new DataTable();
            dt2.Columns.Add("ID", typeof(int));
            dt2.Columns.Add("PID", typeof(int));
            dt2.Columns.Add("A");
            dt2.Columns.Add("B");
            dt2.Columns.Add("C");

            DataTable dt3 = new DataTable();
            dt3.Columns.Add("ID", typeof(int));
            dt3.Columns.Add("PID", typeof(int));
            dt3.Columns.Add("A");
            dt3.Columns.Add("B");

            for (int i = 0; i < maxRows; i++)
            {
                dt.Rows.Add(i,"Item " + i.ToString(), "Value " + i.ToString(), "Description " + i.ToString());
                for (int j = 0; j < maxRows; j++)
                {
                    dt2.Rows.Add(i,j,"Item " + j.ToString(), "Value " + i.ToString(), "Description " + j.ToString());
                    dt3.Rows.Add(i, j, "Item " + j.ToString(), "Value " + i.ToString());
                }
            }

            ds.Tables.Add(dt);
            ds.Tables.Add(dt2);
            ds.Tables.Add(dt3);

            DataRelation dr = new DataRelation("DR", dt.Columns["ID"], dt2.Columns["PID"], true);
            ds.Relations.Add(dr);

            DataRelation dr2 = new DataRelation("DR2", dt2.Columns["ID"], dt3.Columns["PID"], false);
            ds.Relations.Add(dr2);
            ultraGrid1.DataSource = ds;

            ultraStatusBar1.Panels[0].ProgressBarInfo.Minimum = 0;
            ultraStatusBar1.Panels[0].ProgressBarInfo.Maximum = Convert.ToInt32(Math.Pow(maxRows, 3));
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            if (this.backgroundWorker1.IsBusy) return;
            this.backgroundWorker1.RunWorkerAsync();
        }

        void ultraGridExcelExporter1_RowExported(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.RowExportedEventArgs e)
        {
            if (ultraStatusBar1.Panels[0].ProgressBarInfo.Value >= 1000) return;
            ultraStatusBar1.Panels[0].ProgressBarInfo.Value += 1;
        }

        void backgroundWorker1_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            Process.Start("..\\..\\Test.xlsx");
        }

        void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            ultraGridExcelExporter1.RowExported += new Infragistics.Win.UltraWinGrid.ExcelExport.RowExportedEventHandler(ultraGridExcelExporter1_RowExported);
            ultraGridExcelExporter1.Export(ultraGrid1, "..\\..\\Test.xlsx", Infragistics.Documents.Excel.WorkbookFormat.Excel2007);
        }
    }
}
